# -------------------------------------------------
# Kernel
# -------------------------------------------------
QT -= core gui
TARGET = Kernel
TEMPLATE = lib
INCLUDEPATH += ./../../../../inc

DEFINES += CSFDB No_Exception

include(Dico.pri)
include(FSD.pri)
include(Message.pri)
include(MMgt.pri)
include(NCollection.pri)
include(OSD.pri)
include(Plugin.pri)
include(Quantity.pri)
include(Resource.pri)
include(SortTools.pri)
include(Standard.pri)
include(StdFail.pri)
include(Storage.pri)
include(TCollection.pri)
include(TColStd.pri)
include(TShort.pri)
include(Units.pri)
include(UnitsAPI.pri)

unix:!macx { 
OPTIMIZE = 3
OPT = -O
    CONFIG(release, debug|release):!isEmpty(OPTIMIZE):*-g++* { 
        QMAKE_CFLAGS_RELEASE ~= s,-O.,$$join(OPT,,, $${OPTIMIZE}),
        QMAKE_CXXFLAGS_RELEASE ~= s,-O.,$$join(OPT,,, $${OPTIMIZE}),
        QMAKE_OBJECTIVE_CFLAGS_RELEASE ~= s,-O.,$$join(OPT,,, $${OPTIMIZE}),
    }
    HARDWARE_PLATFORM = $$system(uname -m)
    contains( HARDWARE_PLATFORM, x86_64 ) { 
        # 64-bit Linux
        message ("Adding Linux 64 bits compile flags and definitions")
        DEFINES += _OCC64
        QMAKE_CXXFLAGS += -m64
    }
    
    # 32-bit Linux
    DEFINES += LIN LININTEL HAVE_CONFIG_H OCC_CONVERT_SIGNALS NDEBUG
    INCLUDEPATH += ./../../../../
    OBJECTS_DIR = ./../../../../Linux/obj/Kernel
    DESTDIR = ./../../../../Linux/bin
}
win32 { 
    LIBS = advapi32.lib gdi32.lib user32.lib

    DEFINES += WIN32 WINDOWS WNT _WINDLL

    DEFINES += __Dico_DLL
    DEFINES += __FSD_DLL
    DEFINES += __MMgt_DLL
    DEFINES += __Message_DLL
    DEFINES += __NCollection_DLL
    DEFINES += __OSD_DLL
    DEFINES += __Plugin_DLL
    DEFINES += __Quantity_DLL
    DEFINES += __Resource_DLL
    DEFINES += __SortTools_DLL
    DEFINES += __Standard_DLL
    DEFINES += __StdFail_DLL
    DEFINES += __Storage_DLL
    DEFINES += __TColStd_DLL
    DEFINES += __TCollection_DLL
    DEFINES += __TShort_DLL
    DEFINES += __Units_DLL
    DEFINES += __UnitsAPI_DLL

    DEFINES -= UNICODE
    OBJECTS_DIR = ./../../../../Win32/obj/Kernel
    DLLDESTDIR = ./../../../../Win32/bin
    DESTDIR = ./../../../../Win32/lib

#    OPTIMIZE = x
#    OPT = -O
#QMAKE_CXXFLAGS_RELEASE ~= s,-O.,$$join(OPT,,, $${OPTIMIZE}),
QMAKE_CXXFLAGS_RELEASE += -wd4996  -wd4100
QMAKE_CXXFLAGS_RTTI_ON  = -Gd
QMAKE_CXXFLAGS_STL_ON   = -EHa
QMAKE_CXXFLAGS_EXCEPTIONS_ON = -EHa
}

macx { 
    DEFINES += OSX # ## is DARWIN a beter choice? Or should we simply use __APPLE__ in the code?
    DEFINES += HAVE_CONFIG_H \
        HAVE_IOSTREAM \
        HAVE_FSTREAM \
        HAVE_LIMITS_H
    QMAKE_LFLAGS_SONAME = -dynamiclib \
        -Wl,-single_module
    QMAKE_CXXFLAGS += -gdwarf-2
    INCLUDEPATH += ./../../
    OBJECTS_DIR = ./../../../../MacOS/obj/Kernel
    DESTDIR = ./../../../../MacOS/bin
}
