# -------------------------------------------------
# Brep
# -------------------------------------------------
QT -= core gui
TARGET = GeomAlgo
TEMPLATE = lib
INCLUDEPATH += ./../../../../inc

DEFINES += CSFDB No_Exception

include(AppBlend.pri)
include(ApproxInt.pri)
include(FairCurve.pri)
include(GccAna.pri)
include(GccEnt.pri)
include(GccInt.pri)
include(GccIter.pri)
include(Geom2dAPI.pri)
include(Geom2dGcc.pri)
include(Geom2dHatch.pri)
include(Geom2dInt.pri)
include(GeomAPI.pri)
include(GeomFill.pri)
include(GeomInt.pri)
include(GeomPlate.pri)
include(Hatch.pri)
include(HatchGen.pri)
include(IntCurve.pri)
include(IntCurveSurface.pri)
include(Intf.pri)
include(IntImp.pri)
include(IntImpParGen.pri)
include(IntPatch.pri)
include(IntPolyh.pri)
include(IntRes2d.pri)
include(IntStart.pri)
include(IntSurf.pri)
include(Law.pri)
include(LocalAnalysis.pri)
include(NLPlate.pri)
include(Plate.pri)
include(TopClass.pri)
include(TopTrans.pri)

unix:!macx { 
OPTIMIZE = 3
OPT = -O
    CONFIG(release, debug|release):!isEmpty(OPTIMIZE):*-g++* { 
        QMAKE_CFLAGS_RELEASE ~= s,-O.,$$join(OPT,,, $${OPTIMIZE}),
        QMAKE_CXXFLAGS_RELEASE ~= s,-O.,$$join(OPT,,, $${OPTIMIZE}),
        QMAKE_OBJECTIVE_CFLAGS_RELEASE ~= s,-O.,$$join(OPT,,, $${OPTIMIZE}),
    }
    HARDWARE_PLATFORM = $$system(uname -m)
    contains( HARDWARE_PLATFORM, x86_64 ) { 
        # 64-bit Linux
        message ("Adding Linux 64 bits compile flags and definitions")
        DEFINES += _OCC64
        QMAKE_CXXFLAGS += -m64
    }
    
    LIBS += -L./../../../../Linux/bin \
    -lKernel \
    -lMath \
    -lG2d \
    -lG3d \
    -lGeomBase \
    -lBrep

    # 32-bit Linux
    DEFINES += LIN LININTEL HAVE_CONFIG_H OCC_CONVERT_SIGNALS NDEBUG
    INCLUDEPATH += ./../../../../
    OBJECTS_DIR = ./../../../../Linux/obj/GeomAlgo
    DESTDIR = ./../../../../Linux/bin
}
win32 { 

    LIBS += ./../../../../Win32/lib/Kernel.lib \
            ./../../../../Win32/lib/Math.lib \
            ./../../../../Win32/lib/G2d.lib \
            ./../../../../Win32/lib/G3d.lib \
            ./../../../../Win32/lib/GeomBase.lib \
            ./../../../../Win32/lib/Brep.lib

    DEFINES += WIN32 WINDOWS WNT _WINDLL

    DEFINES += __AppBlend_DLL
    DEFINES += __ApproxInt_DLL
    DEFINES += __FairCurve_DLL
    DEFINES += __GccAna_DLL
    DEFINES += __GccEnt_DLL
    DEFINES += __GccInt_DLL
    DEFINES += __GccIter_DLL
    DEFINES += __Geom2dAPI_DLL
    DEFINES += __Geom2dGcc_DLL
    DEFINES += __Geom2dHatch_DLL
    DEFINES += __Geom2dInt_DLL
    DEFINES += __GeomAPI_DLL
    DEFINES += __GeomFill_DLL
    DEFINES += __GeomInt_DLL
    DEFINES += __GeomPlate_DLL
    DEFINES += __Hatch_DLL
    DEFINES += __HatchGen_DLL
    DEFINES += __IntCurve_DLL
    DEFINES += __IntCurveSurface_DLL
    DEFINES += __IntImp_DLL
    DEFINES += __IntImpParGen_DLL
    DEFINES += __IntPatch_DLL
    DEFINES += __IntPolyh_DLL
    DEFINES += __IntRes2d_DLL
    DEFINES += __IntStart_DLL
    DEFINES += __IntSurf_DLL
    DEFINES += __Intf_DLL
    DEFINES += __Law_DLL
    DEFINES += __LocalAnalysis_DLL
    DEFINES += __NLPlate_DLL
    DEFINES += __Plate_DLL
    DEFINES += __TopClass_DLL
    DEFINES += __TopTrans_DLL

    DEFINES -= UNICODE
    OBJECTS_DIR = ./../../../../Win32/obj/GeomAlgo
    DLLDESTDIR = ./../../../../Win32/bin
    DESTDIR = ./../../../../Win32/lib

#    OPTIMIZE = x
#    OPT = -O
#QMAKE_CXXFLAGS_RELEASE ~= s,-O.,$$join(OPT,,, $${OPTIMIZE}),
QMAKE_CXXFLAGS_RELEASE += -wd4996  -wd4100
QMAKE_CXXFLAGS_RTTI_ON  = -Gd
QMAKE_CXXFLAGS_STL_ON   = -EHa
QMAKE_CXXFLAGS_EXCEPTIONS_ON = -EHa
}

macx { 
    DEFINES += OSX # ## is DARWIN a beter choice? Or should we simply use __APPLE__ in the code?
    DEFINES += HAVE_CONFIG_H \
        HAVE_IOSTREAM \
        HAVE_FSTREAM \
        HAVE_LIMITS_H
    QMAKE_LFLAGS_SONAME = -dynamiclib \
        -Wl,-single_module
    QMAKE_CXXFLAGS += -gdwarf-2
    INCLUDEPATH += ./../../
    OBJECTS_DIR = ./../../../../MacOS/obj/GeomAlgo
    DESTDIR = ./../../../../MacOS/bin
}
