# -------------------------------------------------
# Brep
# -------------------------------------------------
QT -= core gui
TARGET = TopAlgo
TEMPLATE = lib
INCLUDEPATH += ./../../../../inc

DEFINES += CSFDB No_Exception

include(Bisector.pri)
include(BRepApprox.pri)
include(BRepBndLib.pri)
include(BRepBuilderAPI.pri)
include(BRepCheck.pri)
include(BRepClass.pri)
include(BRepClass3d.pri)
include(BRepExtrema.pri)
include(BRepGProp.pri)
include(BRepIntCurveSurface.pri)
include(BRepLib.pri)
include(BRepMAT2d.pri)
include(BRepTopAdaptor.pri)
include(IntCurvesFace.pri)
include(MAT.pri)
include(MAT2d.pri)

unix:!macx { 
OPTIMIZE = 3
OPT = -O
    CONFIG(release, debug|release):!isEmpty(OPTIMIZE):*-g++* { 
        QMAKE_CFLAGS_RELEASE ~= s,-O.,$$join(OPT,,, $${OPTIMIZE}),
        QMAKE_CXXFLAGS_RELEASE ~= s,-O.,$$join(OPT,,, $${OPTIMIZE}),
        QMAKE_OBJECTIVE_CFLAGS_RELEASE ~= s,-O.,$$join(OPT,,, $${OPTIMIZE}),
    }
    HARDWARE_PLATFORM = $$system(uname -m)
    contains( HARDWARE_PLATFORM, x86_64 ) { 
        # 64-bit Linux
        message ("Adding Linux 64 bits compile flags and definitions")
        DEFINES += _OCC64
        QMAKE_CXXFLAGS += -m64
    }
    
    LIBS += -L./../../../../Linux/bin \
    -lKernel \
    -lMath \
    -lG2d \
    -lG3d \
    -lGeomBase \
    -lBrep \
    -lGeomAlgo

    # 32-bit Linux
    DEFINES += LIN LININTEL HAVE_CONFIG_H OCC_CONVERT_SIGNALS NDEBUG
    INCLUDEPATH += ./../../../../
    OBJECTS_DIR = ./../../../../Linux/obj/TopAlgo
    DESTDIR = ./../../../../Linux/bin
}
win32 { 

    LIBS += ./../../../../Win32/lib/Kernel.lib \
            ./../../../../Win32/lib/Math.lib \
            ./../../../../Win32/lib/G2d.lib \
            ./../../../../Win32/lib/G3d.lib \
            ./../../../../Win32/lib/GeomBase.lib \
            ./../../../../Win32/lib/Brep.lib \
            ./../../../../Win32/lib/GeomAlgo.lib

    DEFINES += WIN32 WINDOWS WNT _WINDLL

    DEFINES += __BRepApprox_DLL
    DEFINES += __BRepBndLib_DLL
    DEFINES += __BRepBuilderAPI_DLL
    DEFINES += __BRepCheck_DLL
    DEFINES += __BRepClass_DLL
    DEFINES += __BRepClass3d_DLL
    DEFINES += __BRepExtrema_DLL
    DEFINES += __BRepGProp_DLL
    DEFINES += __BRepIntCurveSurface_DLL
    DEFINES += __BRepLib_DLL
    DEFINES += __BRepMAT2d_DLL
    DEFINES += __BRepTopAdaptor_DLL
    DEFINES += __Bisector_DLL
    DEFINES += __IntCurvesFace_DLL
    DEFINES += __MAT_DLL
    DEFINES += __MAT2d_DLL

    DEFINES -= UNICODE
    OBJECTS_DIR = ./../../../../Win32/obj/TopAlgo
    DLLDESTDIR = ./../../../../Win32/bin
    DESTDIR = ./../../../../Win32/lib

#    OPTIMIZE = x
#    OPT = -O
#QMAKE_CXXFLAGS_RELEASE ~= s,-O.,$$join(OPT,,, $${OPTIMIZE}),
QMAKE_CXXFLAGS_RELEASE += -wd4996  -wd4100
QMAKE_CXXFLAGS_RTTI_ON  = -Gd
QMAKE_CXXFLAGS_STL_ON   = -EHa
QMAKE_CXXFLAGS_EXCEPTIONS_ON = -EHa
}

macx { 
    DEFINES += OSX # ## is DARWIN a beter choice? Or should we simply use __APPLE__ in the code?
    DEFINES += HAVE_CONFIG_H \
        HAVE_IOSTREAM \
        HAVE_FSTREAM \
        HAVE_LIMITS_H
    QMAKE_LFLAGS_SONAME = -dynamiclib \
        -Wl,-single_module
    QMAKE_CXXFLAGS += -gdwarf-2
    INCLUDEPATH += ./../../
    OBJECTS_DIR = ./../../../../MacOS/obj/TopAlgo
    DESTDIR = ./../../../../MacOS/bin
}
